/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.PropConf$Battle
 *  mkdb.Lockeys
 *  mkdb.Procedure
 *  mkdb.TTable
 *  mkio.Protocol
 *  xbean.BattleInfo
 *  xbean.Fighter
 *  xtable.Battle
 *  xtable.Locks
 *  xtable.Roleid2battleid
 */
package fire.pb.battle;

import fire.pb.PropConf;
import fire.pb.battle.BattleField;
import fire.pb.battle.Fighter;
import fire.pb.battle.FighterInfo;
import fire.pb.battle.PRoundPLayEnd;
import fire.pb.battle.SSendAddFighters;
import fire.pb.battle.SSendBattleStart;
import fire.pb.battle.SSendBattlerOperateState;
import fire.pb.battle.SSendPetInitAttrs;
import fire.pb.battle.SSendRoleInitAttrs;
import fire.pb.battle.SSendRoundStart;
import java.util.LinkedList;
import mkdb.Lockeys;
import mkdb.Procedure;
import mkdb.TTable;
import mkio.Protocol;
import xbean.BattleInfo;
import xtable.Battle;
import xtable.Locks;
import xtable.Roleid2battleid;

public class PEnterBattleAfterEnterWorld
extends Procedure {
    private final long roleId;

    public PEnterBattleAfterEnterWorld(long roleId) {
        this.roleId = roleId;
    }

    protected boolean process() {
        Long battleId = Roleid2battleid.select((Long)this.roleId);
        if (battleId == null) {
            return true;
        }
        BattleInfo battle = Battle.get((Long)battleId);
        if (battle == null) {
            return true;
        }
        this.lock(Lockeys.get((TTable)Locks.ROLELOCK, battle.getRoleids().keySet()));
        Integer fighterId = (Integer)battle.getRoleids().get(this.roleId);
        if (fighterId == null) {
            return true;
        }
        boolean ishost = BattleField.isHost(fighterId);
        SSendBattleStart snd = new SSendBattleStart();
        snd.battletype = battle.getBattletype();
        snd.battleconfigid = battle.getConfigid();
        snd.roundnum = battle.getPhase() == 1 ? battle.getRound() - 1 : battle.getRound();
        snd.enemyside = ishost ? 0 : 1;
        snd.friendsformation = ishost ? battle.getHostform() : battle.getGuestform();
        snd.enemyformation = ishost ? battle.getGuestform() : battle.getHostform();
        snd.friendsformationlevel = ishost ? battle.getHostformlevel() : battle.getHostformlevel();
        snd.enemyformationlevel = ishost ? battle.getHostformlevel() : battle.getHostformlevel();
        snd.background = (byte)battle.getBackground();
        snd.backmusic = (byte)battle.getBgm();
        Procedure.psendWhileCommit((long)this.roleId, (Protocol)snd);
        Fighter opfighter = (Fighter)battle.getFighterobjects().get(fighterId);
        SSendRoleInitAttrs sroleattr = new SSendRoleInitAttrs();
        sroleattr.roleinitattrs.putAll(opfighter.getFighterBean().getInitattrs());
        PEnterBattleAfterEnterWorld.psendWhileCommit((long)this.roleId, (Protocol)sroleattr);
        opfighter.sendAlreadyUsedItems();
        xbean.Fighter petfighter = (xbean.Fighter)battle.getFighters().get(fighterId + 5);
        if (petfighter != null) {
            SSendPetInitAttrs spetattr = new SSendPetInitAttrs();
            spetattr.petinitattrs.putAll(petfighter.getInitattrs());
            PEnterBattleAfterEnterWorld.psendWhileCommit((long)this.roleId, (Protocol)spetattr);
        }
        SSendAddFighters addsnd = new SSendAddFighters();
        for (xbean.Fighter f : battle.getFighters().values()) {
            if (BattleField.checkOutBattle(battle, f.getBattleindex())) continue;
            FighterInfo fi = BattleField.getFighterInfo(f, battle);
            addsnd.fighterlist.add(fi);
        }
        int watchernum = Math.min(PropConf.Battle.WATCHERS_IN_BATTLE, battle.getWatchers().size());
        for (int i = 31; i < 31 + watchernum; ++i) {
            xbean.Fighter f = (xbean.Fighter)battle.getWatchers().get(i);
            if (f == null) continue;
            addsnd.fighterlist.add(BattleField.getWatcherFighterInfo(f, battle));
        }
        Procedure.psendWhileCommit((long)this.roleId, (Protocol)addsnd);
        if (battle.getPhase() == 1) {
            int remainTime = (int)((double)(30 * battle.getGmactiontimetimes()) / 10.0 - (double)((System.currentTimeMillis() - battle.getRoundtime()) / 1000L));
            if (remainTime > 0) {
                SSendRoundStart roundstart = new SSendRoundStart();
                roundstart.time = remainTime;
                roundstart.environment = battle.getEnvironment();
                PEnterBattleAfterEnterWorld.psendWhileCommit((long)this.roleId, (Protocol)roundstart);
                if (!battle.getDecisions().containsKey(fighterId)) {
                    PEnterBattleAfterEnterWorld.psendWhileCommit(battle.getRoleids().keySet(), (Protocol)new SSendBattlerOperateState(fighterId, 1));
                } else {
                    PEnterBattleAfterEnterWorld.psendWhileCommit(battle.getRoleids().keySet(), (Protocol)new SSendBattlerOperateState(fighterId, 2));
                }
                if (!battle.getDecisions().containsKey(fighterId + 5)) {
                    PEnterBattleAfterEnterWorld.psendWhileCommit(battle.getRoleids().keySet(), (Protocol)new SSendBattlerOperateState(fighterId + 5, 1));
                } else {
                    PEnterBattleAfterEnterWorld.psendWhileCommit(battle.getRoleids().keySet(), (Protocol)new SSendBattlerOperateState(fighterId + 5, 2));
                }
            }
        } else {
            PEnterBattleAfterEnterWorld.psendWhileCommit(battle.getRoleids().keySet(), (Protocol)new SSendBattlerOperateState(fighterId, 0));
        }
        battle.getOfflineroleids().remove(this.roleId);
        if (!battle.getFeedbacks().contains(this.roleId)) {
            PEnterBattleAfterEnterWorld.pexecuteWhileCommit((Procedure)new PRoundPLayEnd(this.roleId, new LinkedList<Integer>(), true));
        }
        return true;
    }
}

